#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,fma")

#include <cstdio>
#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace std;
using ll = long long;

constexpr int MAXN = 1e5;
struct circle {
    int x, y, r, idx;
} circles[MAXN + MAXN];
int ans[MAXN];
vector<int> tree[MAXN + MAXN];
bool used[MAXN + MAXN];
int dp[MAXN + MAXN];
int idx[10000001];

typedef pair<int, int> pt;
typedef vector<int> VI;
typedef vector<VI> VVI;
vector<map<pt, VVI>> chain(30);

inline bool encloses(int big, int small) {
    ll dx = circles[big].x - circles[small].x;
    ll dy = circles[big].y - circles[small].y;
    return dx * dx + dy * dy <= 1LL * circles[big].r * circles[big].r;
}

inline bool doesNotEnclose(int big, int small) {
    return !encloses(big, small);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, q;
    scanf(" %d %d", &n, &q);
    for (int i = 0; i < n + q; ++i) {
        scanf(" %d %d %d", &circles[i].x, &circles[i].y, &circles[i].r);
        circles[i].x += 20000000;
        circles[i].y += 20000000;
        circles[i].idx = i - n;
    }

    sort(circles, circles + n + q, [](const circle& a, const circle& b) {
        return a.r < b.r;
    });

    for (int i = n + q - 1; i >= 0; --i) {
        int log = 0;
        int x = circles[i].x;
        int y = circles[i].y;
        int r = circles[i].r;
        while (1 << log < r) log++;
        log++;

        bool found = false;
        set<pt> buckets;
        buckets.insert(pt((x + r) >> log, (y + r) >> log));
        buckets.insert(pt((x + r) >> log, (y - r) >> log));
        buckets.insert(pt((x - r) >> log, (y + r) >> log));
        buckets.insert(pt((x - r) >> log, (y - r) >> log));
        for (auto bit = buckets.begin(); bit != buckets.end(); bit++) {
            bool innerFound = false;
            for (auto it = chain[log][*bit].begin(); it != chain[log][*bit].end(); it++) {
                if (encloses(it->back(), i)) {
                    if (!found) tree[it->back()].push_back(i);
                    it->push_back(i);
                    found = innerFound = true;
                    break;
                }
            }
            if (!innerFound) chain[log][*bit].push_back({i});
        }

        for (int j = log + 1; j < 30 && !found; j++) {
            pt bucket(x >> j, y >> j);
            for (auto it = chain[j][bucket].begin(); it != chain[j][bucket].end(); it++) {
                auto pit = lower_bound(it->rbegin(), it->rend(), i, doesNotEnclose);
                if (pit != it->rend()) {
                    tree[*pit].push_back(i);
                    found = true;
                    break;
                }
            }
        }
    }

    for (int u = 0; u < n + q; ++u) {
        bool used_child = false;
        for (int v : tree[u]) {
            dp[u] += dp[v];
            used_child |= used[v];
        }

        if (circles[u].idx >= 0) {
            used[u] = used_child;
            ans[circles[u].idx] = dp[u] + !used[u];
        } else {
            if (!used_child) {
                used[u] = true;
                ++dp[u];
            }
        }
    }

    for (int i = 0; i < q; ++i) {
        printf("%d\n", ans[i]);
    }

    return 0;
}
