import java.util.*;

public class bomas_quadratic_AN {
  static class Circle {
    final long x, y, r, q;
    boolean isSelected = false;
    int value = 0;
    Circle parent = null;
    ArrayList<Circle> children = new ArrayList<Circle>();

    public Circle(long x, long y, long r, long q) {
      this.x = x;
      this.y = y;
      this.r = r;
      this.q = q;
    }

    public void addChild(Circle c) {
      c.parent = this;
      children.add(c);
    }

    public boolean encloses(Circle c) {
      long dx = this.x - c.x;
      long dy = this.y - c.y;
      return dx * dx + dy * dy < r * r;
    }
  }

  public static void main(String[] args) {
    Scanner s = new Scanner(System.in);
    int n = s.nextInt(), m = s.nextInt();

    Circle[] circles = new Circle[n + m];
    for (int i = 0; i < n; i++) {
      circles[i] = new Circle(s.nextLong(), s.nextLong(), s.nextLong(), -1);
    }
    for (int i = 0; i < m; i++) {
      circles[n + i] = new Circle(s.nextLong(), s.nextLong(), s.nextLong(), i);
    }

    Arrays.sort(circles, (Circle o1, Circle o2) -> Long.compare(o1.r, o2.r));
    for (int i = 0; i < n + m; i++) {
      for (int j = i + 1; j < n + m; j++) {
        if (circles[j].encloses(circles[i])) {
          circles[j].addChild(circles[i]);
          break;
        }
      }
    }

    for (Circle c : circles) {
      boolean hasSelectedChild = c.children.stream().anyMatch((circle) -> circle.isSelected);
      int childrenSum = c.children.stream().mapToInt((circle) -> circle.value).sum();
      if (c.q >= 0) {
        c.isSelected = hasSelectedChild;
        c.value = childrenSum;
      } else {
        c.isSelected = !hasSelectedChild;
        c.value = childrenSum + (hasSelectedChild ? 0 : 1);
      }
    }

    Arrays.sort(circles, (Circle o1, Circle o2) -> Long.compare(o1.q, o2.q));
    for (Circle c : circles) if (c.q >= 0) System.out.println(c.value + (c.isSelected ? 0 : 1));
  }
}
